<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <s:decorate template="/hl7Initiators/resultSenderTemplate.xhtml">
            <ui:param name="managedBean" value="#{orderResultManager}"/>
            <!-- page title -->
            <ui:define name="pageTitle">
                <h:outputText value="#{messages['gazelle.ordermanager.OrderResultManagementOF']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('ORT')}"/>
                <h:outputText value="#{messages['gazelle.ordermanager.TestResultManagementAM']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('OF')}"/>
                <h:outputText value="#{messages['gazelle.ordermanager.AWOSStatusChange']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('ANALYZER_MGR')}"/>
            </ui:define>
            <!-- main panel title -->
            <ui:define name="mainPanelTitle">
                <h:outputText value="#{messages['gazelle.ordermanager.SendOrderResultsToYourOrderResultTracker']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('ORT')}"/>
                <h:outputText value="#{messages['gazelle.ordermanager.SendTestResultsToYourOrderFiller']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('OF')}"/>
                <h:outputText value="#{messages['gazelle.ordermanager.SendTestResultsToYourAnalyzerManager']}"
                              rendered="#{orderResultManager.sutActorKeyword.equals('ANALYZER_MGR')}"/>
            </ui:define>
            <!-- message structure selection /LAW options for ANALYZER -->
            <ui:define name="messageStructureSelection">
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                rendered="#{not orderResultManager.simulatedActor.keyword.equals('ANALYZER')}">
                        <ui:define name="label">#{messages['gazelle.ordermanager.MessageStructureToUse']}</ui:define>
                        <ui:param name="id" value="struct"/>
                        <h:selectOneMenu value="#{orderResultManager.messageStructure}" id="struct"
                                         styleClass="form-control">
                            <f:selectItems value="#{orderResultManager.listAvailableActions()}"/>
                            <a4j:ajax event="change" render="globalDiv"
                                      listener="#{orderResultManager.onChangeActionEvent()}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                rendered="#{orderResultManager.simulatedActor.keyword.equals('ANALYZER')}">
                        <ui:define name="label">#{messages['gazelle.ordermanager.LAWOptions']}</ui:define>
                        <ui:param name="id" value="optionsIn"/>
                        <rich:pickList id="optionsIn"
                                       value="#{orderResultManager.selectedOptions}" listWidth="500px">
                            <s:selectItems value="#{orderResultManager.getAvailableOptionsForLAW()}"
                                           var="opt"
                                           label="#{opt.displayName}"/>
                        </rich:pickList>
                        <h:outputText styleClass="help-block"
                                      value="#{messages['gazelle.ordermanager.SelectTheOptionsSupportedByYourSystem']}"/>
                    </s:decorate>
                </div>
            </ui:define>
            <!-- result configuration -->
            <ui:define name="resultConfiguration">
                <!-- BATTERY CENTRIC case -->
                <s:div id="batteryCentric"
                       rendered="#{orderResultManager.messageStructure.equals(orderResultManager.batteryCentric)           and orderResultManager.selectedOrder != null}">
                    <gri:panel pid="orderDetailPanel">
                        <f:facet name="header">
                            <s:div>
                                <h:outputText value="#{messages['gazelle.ordermanager.OrderDetails']}"
                                              rendered="#{not orderResultManager.workOrder}"/>
                                <h:outputText value="#{messages['gazelle.ordermanager.WorkOrderDetails']}"
                                              rendered="#{orderResultManager.workOrder}"/>
                            </s:div>
                        </f:facet>
                        <div class="row">
                            <f:subview id="orc_details_view">
                                <ui:include src="/lab/labOrderDetails.xhtml">
                                    <ui:param name="selectedOrder" value="#{orderResultManager.selectedOrder}"/>
                                    <ui:param name="enableStatusEdit" value="true"/>
                                    <ui:param name="managedBean" value="#{orderResultManager}"/>
                                </ui:include>
                            </f:subview>
                        </div>
                        <h:outputText
                                value="#{messages['gazelle.ordermanager.BelowIsTheListOfRelatedObservations']}"
                                styleClass="help-block"
                                rendered="#{not empty orderResultManager.selectedOrder.observations}"/>
                        <s:decorate template="/lab/observationsTable.xhtml"
                                    rendered="#{not empty orderResultManager.selectedOrder.observations}">
                            <ui:param name="observations" value="#{orderResultManager.selectedOrder.observations}"/>
                            <ui:param name="allowUpdate" value="true"/>
                            <ui:param name="managedBean" value="#{orderResultManager}"/>
                            <ui:define name="additionalColumns">
                                <g:column>
                                    <ui:define name="header">#{messages['gazelle.HL7Common.Action']}</ui:define>
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.Edit']}"
                                                     actionListener="#{orderResultManager.selectObservationForEdit(obs)}"
                                                     render="resultConfiguration">
                                        <s:span styleClass="gzl-icon-pencil"/>
                                    </a4j:commandLink>
                                </g:column>
                            </ui:define>
                        </s:decorate>
                        <s:div rendered="#{empty orderResultManager.selectedOrder.observations}"
                               styleClass="gzl-alert gzl-alert-orange">
                            <h:outputText value="#{messages['gazelle.ordermanager.NoObservationReportedYet']}"/>
                        </s:div>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['gazelle.ordermanager.AddAnObservationToThisOrder']}"
                                               actionListener="#{orderResultManager.createNewObservationForOrder()}"
                                               styleClass="gzl-btn-green"
                                               render="resultConfiguration"/>
                        </f:facet>
                    </gri:panel>
                    <br/>
                    <gri:panel pid="orderSpecimensListPanel">
                        <f:facet name="header">#{messages['gazelle.ordermanager.RelatedSpecimens']}</f:facet>
                        #{dataTableStateHolder.setDescendingOn('lastChanged')}
                        <rich:dataTable value="#{orderResultManager.getSpecimensAsDataModelForSelectedOrder()}"
                                        var="spm" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        render="ds" id="orcspmlist" rowKeyVar="rowNumber">
                            <ui:include src="/lab/specimenColumns.xhtml">
                                <ui:param name="specimen" value="#{spm}"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['net.ihe.gazelle.patgen.Actions']}</ui:define>
                                <a4j:commandLink
                                        title="#{messages['gazelle.ordermanager.AddAnObservationToThisSpecimen']}"
                                        actionListener="#{orderResultManager.createNewObservationForSpecimen(spm)}"
                                        render="resultConfiguration">
                                    <s:span styleClass="gzl-icon-plus"/>
                                </a4j:commandLink>
                            </g:column>
                            <ui:include src="/lab/observationColspan.xhtml">
                                <ui:param name="colNumber" value="1"/>
                                <ui:param name="observations" value="#{spm.observations}"/>
                                <ui:param name="spm" value="#{spm}"/>
                                <ui:param name="currentOrder" value="null"/>
                                <ui:param name="parentType" value="specimen"/>
                                <ui:param name="displayAddButton" value="true"/>
                                <ui:param name="allowRerun" value="#{messages['net.ihe.gazelle.False']}"/>
                            </ui:include>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="orcspmlist"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </gri:panel>
                </s:div>
                <!-- SPECIMEN-CENTRIC case (applicable for LAW)-->
                <s:div id="specimenCentric"
                       rendered="#{not orderResultManager.messageStructure.equals(orderResultManager.batteryCentric)
                       and orderResultManager.selectedSpecimen != null}">
                    <gri:panel pid="specimenDetailsPanel">
                        <f:facet name="header">#{messages['gazelle.ordermanager.SpecimenDetails']}</f:facet>
                        <div class="row">
                            <f:subview id="spm_details_view"
                                       rendered="#{not orderResultManager.simulatedActor.keyword.equals('ANALYZER')}">
                                <ui:include
                                        src="/lab/specimenDetails.xhtml">
                                    <ui:param name="specimen" value="#{orderResultManager.selectedSpecimen}"/>
                                </ui:include>
                            </f:subview>
                            <f:subview id="awos_details_view"
                                       rendered="#{orderResultManager.simulatedActor.keyword.equals('ANALYZER')}">
                                <ui:include src="/lab/specimenDetailsForAnalyzer.xhtml">
                                    <ui:param name="specimen" value="#{orderResultManager.selectedSpecimen}"/>
                                    <ui:param name="managedBean" value="#{orderResultManager}"/>
                                </ui:include>
                            </f:subview>
                        </div>
                        <s:div rendered="#{not empty orderResultManager.selectedSpecimen.observations}">
                            <h:outputText
                                    value="#{messages['gazelle.ordermanager.BelowIsTheListOfRelatedObservations']}"
                                    styleClass="help-block"/>
                            <ui:decorate template="/lab/observationsTable.xhtml">
                                <ui:param name="observations"
                                          value="#{orderResultManager.selectedSpecimen.observations}"/>
                                <ui:param name="allowUpdate" value="true"/>
                                <ui:param name="managedBean" value="#{orderResultManager}"/>
                                <ui:define name="additionalColumns">
                                    <g:column>
                                        <ui:define name="header">#{messages['gazelle.HL7Common.Action']}</ui:define>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Edit']}"
                                                         actionListener="#{orderResultManager.selectObservationForEdit(obs)}"
                                                         render="resultConfiguration">
                                            <s:span styleClass="gzl-icon-pencil"/>
                                        </a4j:commandLink>
                                    </g:column>
                                </ui:define>
                            </ui:decorate>
                        </s:div>
                        <s:div rendered="#{empty orderResultManager.selectedSpecimen.observations}"
                               styleClass="gzl-alert gzl-alert-orange">
                            <h:outputText value="#{messages['gazelle.ordermanager.NoObservationReportedYet']}"/>
                        </s:div>
                        <f:facet name="footer">
                            <a4j:commandButton
                                    value="#{messages['gazelle.ordermanager.AddAnObservationToThisSpecimen']}"
                                    actionListener="#{orderResultManager.createNewObservationForSpecimen()}"
                                    render="resultConfiguration" styleClass="gzl-btn-green"/>
                        </f:facet>
                    </gri:panel>
                    <gri:panel rendered="#{not empty orderResultManager.selectedSpecimen.containers}"
                               pid="specimenContainerList">
                        <f:facet name="header">#{messages['gazelle.ordermanager.RelatedContainers']}</f:facet>
                        <a4j:repeat value="#{orderResultManager.getContainerDataModelForSelectedSpecimen()}"
                                    var="sac">
                            <f:subview id="sac_details_view">
                                <ui:include src="/lab/containerDetails.xhtml">
                                    <ui:param name="container" value="#{sac}"/>
                                    <ui:param name="displayOrders" value="false"/>
                                </ui:include>
                            </f:subview>
                            <s:div rendered="#{not empty sac.orders}">
                                <h2>#{messages['gazelle.ordermanager.RelatedOrders']}</h2>
                                <ui:include src="/lab/ordersWithObservationsTable.xhtml">
                                    <ui:param name="orders" value="#{orderResultManager.getOrdersAsDataModel(sac)}"/>
                                    <ui:param name="managedBean" value="#{orderResultManager}"/>
                                    <ui:param name="displayAddButton" value="true"/>
                                </ui:include>
                            </s:div>
                        </a4j:repeat>
                    </gri:panel>
                    <gri:panel rendered="#{not empty orderResultManager.selectedSpecimen.orders}"
                               pid="specimenOrdersListPanel">
                        <f:facet name="header">
                            <s:div>
                                <h:outputText value="#{messages['gazelle.ordermanager.RelatedWorkOrders']}"
                                              rendered="#{orderResultManager.workOrder}"/>
                                <h:outputText value="#{messages['gazelle.ordermanager.RelatedOrders']}"
                                              rendered="#{not orderResultManager.workOrder}"/>
                            </s:div>
                        </f:facet>
                        <f:subview id="orc_list_view">
                            <ui:include src="/lab/ordersWithObservationsTable.xhtml">
                                <ui:param name="orders"
                                          value="#{orderResultManager.getOrdersAsDataModelForSelectedSpecimen()}"/>
                                <ui:param name="managedBean" value="#{orderResultManager}"/>
                                <ui:param name="displayAddButton" value="true"/>
                            </ui:include>
                        </f:subview>
                    </gri:panel>
                </s:div>
            </ui:define>
            <ui:define name="newResultConfiguration">
                <ui:include src="/lab/createResultFromScratch.xhtml">
                    <ui:param name="managedBean" value="#{orderResultManager}"/>
                </ui:include>
            </ui:define>
        </s:decorate>
    </ui:define>
</ui:composition>
